<?php
/**
 * InlineResponse20033Content
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20033Content Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20033Content implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_33_content';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'displayId' => 'int',
        'name' => 'string',
        'matchcode' => 'string',
        'street' => 'string',
        'postcode' => 'string',
        'city' => 'string',
        'country' => 'string',
        'note' => 'string',
        'headquarterId' => 'int',
        'email' => 'string',
        'website' => 'string',
        'supportInfo' => 'string',
        'lockout' => 'bool',
        'lockoutReason' => 'string',
        'inactive' => 'bool',
        'telephone' => 'string',
        'telefax' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'displayId' => null,
        'name' => null,
        'matchcode' => null,
        'street' => null,
        'postcode' => null,
        'city' => null,
        'country' => null,
        'note' => null,
        'headquarterId' => null,
        'email' => null,
        'website' => null,
        'supportInfo' => null,
        'lockout' => null,
        'lockoutReason' => null,
        'inactive' => null,
        'telephone' => null,
        'telefax' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'displayId' => 'displayId',
        'name' => 'name',
        'matchcode' => 'matchcode',
        'street' => 'street',
        'postcode' => 'postcode',
        'city' => 'city',
        'country' => 'country',
        'note' => 'note',
        'headquarterId' => 'headquarterId',
        'email' => 'email',
        'website' => 'website',
        'supportInfo' => 'supportInfo',
        'lockout' => 'lockout',
        'lockoutReason' => 'lockoutReason',
        'inactive' => 'inactive',
        'telephone' => 'telephone',
        'telefax' => 'telefax'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'displayId' => 'setDisplayId',
        'name' => 'setName',
        'matchcode' => 'setMatchcode',
        'street' => 'setStreet',
        'postcode' => 'setPostcode',
        'city' => 'setCity',
        'country' => 'setCountry',
        'note' => 'setNote',
        'headquarterId' => 'setHeadquarterId',
        'email' => 'setEmail',
        'website' => 'setWebsite',
        'supportInfo' => 'setSupportInfo',
        'lockout' => 'setLockout',
        'lockoutReason' => 'setLockoutReason',
        'inactive' => 'setInactive',
        'telephone' => 'setTelephone',
        'telefax' => 'setTelefax'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'displayId' => 'getDisplayId',
        'name' => 'getName',
        'matchcode' => 'getMatchcode',
        'street' => 'getStreet',
        'postcode' => 'getPostcode',
        'city' => 'getCity',
        'country' => 'getCountry',
        'note' => 'getNote',
        'headquarterId' => 'getHeadquarterId',
        'email' => 'getEmail',
        'website' => 'getWebsite',
        'supportInfo' => 'getSupportInfo',
        'lockout' => 'getLockout',
        'lockoutReason' => 'getLockoutReason',
        'inactive' => 'getInactive',
        'telephone' => 'getTelephone',
        'telefax' => 'getTelefax'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['displayId'] = $data['displayId'] ?? null;
        $this->container['name'] = $data['name'] ?? null;
        $this->container['matchcode'] = $data['matchcode'] ?? null;
        $this->container['street'] = $data['street'] ?? null;
        $this->container['postcode'] = $data['postcode'] ?? null;
        $this->container['city'] = $data['city'] ?? null;
        $this->container['country'] = $data['country'] ?? null;
        $this->container['note'] = $data['note'] ?? null;
        $this->container['headquarterId'] = $data['headquarterId'] ?? null;
        $this->container['email'] = $data['email'] ?? null;
        $this->container['website'] = $data['website'] ?? null;
        $this->container['supportInfo'] = $data['supportInfo'] ?? null;
        $this->container['lockout'] = $data['lockout'] ?? null;
        $this->container['lockoutReason'] = $data['lockoutReason'] ?? null;
        $this->container['inactive'] = $data['inactive'] ?? null;
        $this->container['telephone'] = $data['telephone'] ?? null;
        $this->container['telefax'] = $data['telefax'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the company
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets displayId
     *
     * @return int|null
     */
    public function getDisplayId()
    {
        return $this->container['displayId'];
    }

    /**
     * Sets displayId
     *
     * @param int|null $displayId This is the \"displayed id\" (=Kundennummer) of the company. The id must be unique, a customer nr. could be used multiple times
     *
     * @return self
     */
    public function setDisplayId($displayId)
    {
        $this->container['displayId'] = $displayId;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name of the company
     *
     * @return self
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets matchcode
     *
     * @return string|null
     */
    public function getMatchcode()
    {
        return $this->container['matchcode'];
    }

    /**
     * Sets matchcode
     *
     * @param string|null $matchcode matchcode (used for searching)
     *
     * @return self
     */
    public function setMatchcode($matchcode)
    {
        $this->container['matchcode'] = $matchcode;

        return $this;
    }

    /**
     * Gets street
     *
     * @return string|null
     */
    public function getStreet()
    {
        return $this->container['street'];
    }

    /**
     * Sets street
     *
     * @param string|null $street street
     *
     * @return self
     */
    public function setStreet($street)
    {
        $this->container['street'] = $street;

        return $this;
    }

    /**
     * Gets postcode
     *
     * @return string|null
     */
    public function getPostcode()
    {
        return $this->container['postcode'];
    }

    /**
     * Sets postcode
     *
     * @param string|null $postcode postal code
     *
     * @return self
     */
    public function setPostcode($postcode)
    {
        $this->container['postcode'] = $postcode;

        return $this;
    }

    /**
     * Gets city
     *
     * @return string|null
     */
    public function getCity()
    {
        return $this->container['city'];
    }

    /**
     * Sets city
     *
     * @param string|null $city city
     *
     * @return self
     */
    public function setCity($city)
    {
        $this->container['city'] = $city;

        return $this;
    }

    /**
     * Gets country
     *
     * @return string|null
     */
    public function getCountry()
    {
        return $this->container['country'];
    }

    /**
     * Sets country
     *
     * @param string|null $country country
     *
     * @return self
     */
    public function setCountry($country)
    {
        $this->container['country'] = $country;

        return $this;
    }

    /**
     * Gets note
     *
     * @return string|null
     */
    public function getNote()
    {
        return $this->container['note'];
    }

    /**
     * Sets note
     *
     * @param string|null $note a note for this company
     *
     * @return self
     */
    public function setNote($note)
    {
        $this->container['note'] = $note;

        return $this;
    }

    /**
     * Gets headquarterId
     *
     * @return int|null
     */
    public function getHeadquarterId()
    {
        return $this->container['headquarterId'];
    }

    /**
     * Sets headquarterId
     *
     * @param int|null $headquarterId if this company is a subsidiary, then here the id of the \"central\" / \"headquerter\" company is given
     *
     * @return self
     */
    public function setHeadquarterId($headquarterId)
    {
        $this->container['headquarterId'] = $headquarterId;

        return $this;
    }

    /**
     * Gets email
     *
     * @return string|null
     */
    public function getEmail()
    {
        return $this->container['email'];
    }

    /**
     * Sets email
     *
     * @param string|null $email e-Mail
     *
     * @return self
     */
    public function setEmail($email)
    {
        $this->container['email'] = $email;

        return $this;
    }

    /**
     * Gets website
     *
     * @return string|null
     */
    public function getWebsite()
    {
        return $this->container['website'];
    }

    /**
     * Sets website
     *
     * @param string|null $website website
     *
     * @return self
     */
    public function setWebsite($website)
    {
        $this->container['website'] = $website;

        return $this;
    }

    /**
     * Gets supportInfo
     *
     * @return string|null
     */
    public function getSupportInfo()
    {
        return $this->container['supportInfo'];
    }

    /**
     * Sets supportInfo
     *
     * @param string|null $supportInfo a support info (internal remark) can be used here
     *
     * @return self
     */
    public function setSupportInfo($supportInfo)
    {
        $this->container['supportInfo'] = $supportInfo;

        return $this;
    }

    /**
     * Gets lockout
     *
     * @return bool|null
     */
    public function getLockout()
    {
        return $this->container['lockout'];
    }

    /**
     * Sets lockout
     *
     * @param bool|null $lockout if true, this company is locked
     *
     * @return self
     */
    public function setLockout($lockout)
    {
        $this->container['lockout'] = $lockout;

        return $this;
    }

    /**
     * Gets lockoutReason
     *
     * @return string|null
     */
    public function getLockoutReason()
    {
        return $this->container['lockoutReason'];
    }

    /**
     * Sets lockoutReason
     *
     * @param string|null $lockoutReason if company is locked, a reason can be given here
     *
     * @return self
     */
    public function setLockoutReason($lockoutReason)
    {
        $this->container['lockoutReason'] = $lockoutReason;

        return $this;
    }

    /**
     * Gets inactive
     *
     * @return bool|null
     */
    public function getInactive()
    {
        return $this->container['inactive'];
    }

    /**
     * Sets inactive
     *
     * @param bool|null $inactive If true, the company is inactive
     *
     * @return self
     */
    public function setInactive($inactive)
    {
        $this->container['inactive'] = $inactive;

        return $this;
    }

    /**
     * Gets telephone
     *
     * @return string|null
     */
    public function getTelephone()
    {
        return $this->container['telephone'];
    }

    /**
     * Sets telephone
     *
     * @param string|null $telephone phone number
     *
     * @return self
     */
    public function setTelephone($telephone)
    {
        $this->container['telephone'] = $telephone;

        return $this;
    }

    /**
     * Gets telefax
     *
     * @return string|null
     */
    public function getTelefax()
    {
        return $this->container['telefax'];
    }

    /**
     * Sets telefax
     *
     * @param string|null $telefax telefax number
     *
     * @return self
     */
    public function setTelefax($telefax)
    {
        $this->container['telefax'] = $telefax;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


